import numpy as np
import matplotlib.pyplot as plt
from scipy import stats

def float_list(l):
    L = []
    for i in l:
        L.append(float(i))
    return(L)

def product_list(L,x, b = None):
    if b is None:
        Lx = []
        for i in L:
            Lx.append(i*x)
        return(Lx)
    else:
        Lx = []
        for i in L:
            Lx.append(i*x +b)
        return(Lx)


def read_data(fichier):
    fichier = open(fichier, "r")
    A = fichier.read()
    L = [[],[],[],[],[]]
    a = ""
    l = 0
    for i in A:
        if (i == " ") :
            if l == 0: 
                L[0].append(a)
                l +=1
            elif l == 1:
                L[1].append(a)
                #print(a)
                l += 1
            elif l == 2:
                L[2].append(a)
                l += 1
            elif l == 3:
                L[3].append(a)
                l += 1
            else:
                L[4].append(a)
                l = 0
            a = ""
        elif (i == "\n") :
            a = ""
        else:
            a += i
    fichier.close()
    for i in range(5):
        L[i] = float_list(L[i])
    L[0] = product_list(L[0],10**-6)
    for i in range(1,5):
        L[i] = product_list(L[i],1000)
    return(L)



def print_graph(L):
#    a = np.array([L[0][i],L[1][i]] for i in range(len(L[0])))
    fig = plt.figure(1)
    plt.clf()
    lr1 = stats.linregress(L[0],L[1]) # return tuple (pente,ordonnee a l'origine, coef de correlation, p-value, erreur standard de l'estimation)
    plt.plot(L[0],L[1], "r", label = "BMP_ref")
    plt.plot(L[0],[lr1.slope*i + lr1.intercept for i in L[0]], "r--", label = "BMP_ref regression line, \nerror = "+str(round(lr1.stderr,3))+",\ncorrelation coefficient = "+str(round(lr1.rvalue,3)))
    
    lr2 = stats.linregress(L[0],L[2])
    plt.plot(L[0],L[2], "b", label = "BMP_impr")
    plt.plot(L[0],[lr2.slope*i + lr2.intercept for i in L[0]], "b--", label = "BMP_impr regression line, \nerror = "+str(round(lr2.stderr,3))+",\ncorrelation coefficient = "+str(round(lr2.rvalue,3)))

    lr3 = stats.linregress(L[0],L[3])
    plt.plot(L[0],L[3], "g", label = "BMP_ref")
    plt.plot(L[0],[lr3.slope*i + lr3.intercept for i in L[0]], "g--", label = "BMP_ref regression line, \nerror = "+str(round(lr3.stderr,3))+",\ncorrelation coefficient = "+str(round(lr3.rvalue,3)))

    lr4 = stats.linregress(L[0],L[4])
    plt.plot(L[0],L[4], "m", label = "BMP_impr")
    plt.plot(L[0],[lr4.slope*i + lr4.intercept for i in L[0]], "m--", label = "BMP_impr regression line, \nerror = "+str(round(lr4.stderr,2))+",\ncorrelation coefficient = "+str(round(lr4.rvalue,3)))
    
    plt.legend()
    plt.xlabel("length in million motor step")
    plt.ylabel("tension in mV")
    plt.show()

def residu(L):
    fig = plt.figure(1)
    plt.clf()
    plt.title("Residu")
    lr1 = stats.linregress(L[0],L[1]) # return tuple (pente (.slope),ordonnee a l'origine (.intercept), coef de correlation (.rvalue), p-value (.pvalue ?), erreur standard de l'estimation (.stderr))
    for i in range(len(L[1])):
        L[1][i] = L[1][i] -  lr1.slope*L[0][i] - lr1.intercept
    plt.plot(L[0],L[1], "r", label = "BMP_ref")
    
    lr2 = stats.linregress(L[0],L[2])
    for i in range(len(L[2])):
        L[2][i] = L[2][i] -  lr2.slope*L[0][i] - lr2.intercept
    plt.plot(L[0],L[2], "b", label = "BMP_impr")

    lr3 = stats.linregress(L[0],L[3])
    for i in range(len(L[3])):
        L[3][i] = L[3][i] -  lr3.slope*L[0][i] - lr3.intercept
    plt.plot(L[0],L[3], "g", label = "BMP_ref")
 
    lr4 = stats.linregress(L[0],L[4])
    for i in range(len(L[4])):
        L[4][i] = L[4][i] -  lr4.slope*L[0][i] - lr4.intercept
    plt.plot(L[0],L[4], "m", label = "BMP_impr")
    plt.legend()
    plt.xlabel("length in million motor step")
    plt.ylabel("tension in mV")
    plt.show()
    
"""    
    ax2 = fig.add_axes((0.1,0.1,0.8,0.0))
    ax2.yaxis.set_visible(False) # hide the yaxis
    ax2.set_xticklabels(10*L[0])
    ax2.set_xlabel("lenght in mm")
    plt.show()
"""

def min_max(L,mini = None ,maxi = None):
    if mini is None :
        mini = -1
    if maxi is None :
        maxi = len(L[0])
    i_min = 0
    i_max = 0
    for i in range(len(L[0])):
        if  L[0][i] <= mini :
            i_min = i
        if  L[0][i] <= maxi :
            i_max = i
    if i_max < len(L[0]) :
        i_max += 1
    return([L[0][i_min:i_max],L[1][i_min:i_max],L[2][i_min:i_max],L[3][i_min:i_max],L[4][i_min:i_max]])


def convertion_step_mm(L,begin_mm,end_mm):
    begin_step = L[0]
    end_step = L[len(L)-1]
    a = float((end_mm - begin_mm))/(end_step - begin_step)
    b = begin_mm - a*begin_step
    print(a,b)
    print(L)
    L = product_list(L, a, b)
    return(L)
    

#L = [[i for i in range(51)] for j in range(5)]
#print(convertion_step_mm(L[0],3.1,44520))

    
def print_data(fichier, min = None, max = None):
    L = min_max(read_data(fichier),min,max)
    print_graph(L)
    #print(L)

def print_residu(fichier, min = None, max = None):
    L = min_max(read_data(fichier), mini = min, maxi = max)
    residu(L)

#print_data("data/position_vs_tension_ch1-3_bpm_ref_ch2-4_bpm_impr_20180611_160153_0.txt",0.1,0.3)
#print_residu("data/position_vs_tension_ch1-3_bpm_ref_ch2-4_bpm_impr_20180611_160153_0.txt",0.1,0.3)

#print_data("data/position_vs_tension_ch1-3_bpm_ref_ch2-4_bpm_impr_20180611_163036_0.txt")

#print_data("data/position_vs_tension_ch1-3_bpm_ref_ch2-4_bpm_impr_vertical_acquisition_20180612_0.txt")
#print_data("data/position_vs_tension_ch1-3_bpm_ref_ch2-4_bpm_impr_vertical_acquisition_20180612_0.txt")
